Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CommonTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CommonTests.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CommonTests.cs	(revision 14398)
@@ -7,5 +7,5 @@
 {
 
-    public abstract class CommonTests<T> : InterpreterTest
+    public abstract class CommonTests<T> : ExpressionTest
     {
         protected const string FullInstructionNameFormat = "{0}.{1}";
@@ -17,10 +17,10 @@
         protected virtual T[] Get2Different()
         {
-            return this.GetValues(2);
+            return GetValues(2);
         }
 
         protected virtual void Test(Expression expression)
         {
-            this.interpreter.Interpret(expression);
+            interpreter.Interpret(expression);
         }
 
@@ -28,22 +28,25 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestEqualsTrue()
         {
-            var values = this.GetValues(1);
+            var values = GetValues(1);
             var merged = new[] { values[0], values[0] };
 
-            this.Stack.Push(merged);
+            Stack.Push(merged);
 
             var isBooleanStack = interpreter.BooleanStack.Count == 2;
 
-            this.Test(ExpressionTable.GetStatelessExpression(this.TypeName + ".="));
+            Test(ExpressionTable.GetStatelessExpression(TypeName + ".="));
 
             if (isBooleanStack)
             {
-                Assert.AreEqual(1, this.Stack.Count);
+                Assert.AreEqual(1, Stack.Count);
             }
             else
             {
-                Assert.AreEqual(0, this.Stack.Count);
+                Assert.AreEqual(0, Stack.Count);
             }
 
@@ -52,19 +55,22 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestEqualsFalse()
         {
-            var values = this.Get2Different();
-            this.Stack.Push(values);
+            var values = Get2Different();
+            Stack.Push(values);
             var isBooleanStack = interpreter.BooleanStack.Count == 2;
 
-            this.Test(ExpressionTable.GetStatelessExpression(this.TypeName + ".="));
+            Test(ExpressionTable.GetStatelessExpression(TypeName + ".="));
 
             if (isBooleanStack)
             {
-                Assert.AreEqual(1, this.Stack.Count);
+                Assert.AreEqual(1, Stack.Count);
             }
             else
             {
-                Assert.AreEqual(0, this.Stack.Count);
+                Assert.AreEqual(0, Stack.Count);
             }
 
@@ -73,166 +79,214 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestEqualsWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("=", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("=", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestPop()
         {
-            var values = this.GetValues(2);
-            this.Stack.Push(values);
-
-            this.Test(ExpressionTable.GetStatelessExpression(this.TypeName + ".POP"));
-
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            var values = GetValues(2);
+            Stack.Push(values);
+
+            Test(ExpressionTable.GetStatelessExpression(TypeName + ".POP"));
+
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestSwap()
         {
-            var values = this.GetValues(3);
-            this.Stack.Push(values);
-
-            this.Test(ExpressionTable.GetStatelessExpression(this.TypeName + ".SWAP"));
-
-            Assert.AreEqual(values[0], this.Stack[0]);
-            Assert.AreEqual(values[2], this.Stack[1]);
-            Assert.AreEqual(values[1], this.Stack[2]);
-
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            var values = GetValues(3);
+            Stack.Push(values);
+
+            Test(ExpressionTable.GetStatelessExpression(TypeName + ".SWAP"));
+
+            Assert.AreEqual(values[0], Stack[0]);
+            Assert.AreEqual(values[2], Stack[1]);
+            Assert.AreEqual(values[1], Stack[2]);
+
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestSwapWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("SWAP", 1);
-        }
-
-
-        [TestMethod]
+            TestWithInsufficientArguments("SWAP", 1);
+        }
+
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestRotate()
         {
-            var values = this.GetValues(4);
-            this.Stack.Push(values);
-
-            this.Test(ExpressionTable.GetStatelessExpression(this.TypeName + ".ROT"));
-
-            Assert.AreEqual(values[0], this.Stack[0]);
-            Assert.AreEqual(values[3], this.Stack[1]);
-            Assert.AreEqual(values[1], this.Stack[2]);
-            Assert.AreEqual(values[2], this.Stack[3]);
-
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            var values = GetValues(4);
+            Stack.Push(values);
+
+            Test(ExpressionTable.GetStatelessExpression(TypeName + ".ROT"));
+
+            Assert.AreEqual(values[0], Stack[0]);
+            Assert.AreEqual(values[3], Stack[1]);
+            Assert.AreEqual(values[1], Stack[2]);
+            Assert.AreEqual(values[2], Stack[3]);
+
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestRotateWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("ROT", 2);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("ROT", 2);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestShove()
         {
-            var values = this.GetValues(3);
-            this.Stack.Push(values);
+            var values = GetValues(3);
+            Stack.Push(values);
 
             interpreter.IntegerStack.Push(1);
-            this.Test(ExpressionTable.GetStatelessExpression(this.TypeName + ".SHOVE"));
-
-            Assert.AreEqual(values[0], this.Stack[0]);
-            Assert.AreEqual(values[2], this.Stack[1]);
-            Assert.AreEqual(values[1], this.Stack[2]);
-
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            Test(ExpressionTable.GetStatelessExpression(TypeName + ".SHOVE"));
+
+            Assert.AreEqual(values[0], Stack[0]);
+            Assert.AreEqual(values[2], Stack[1]);
+            Assert.AreEqual(values[1], Stack[2]);
+
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestShoveWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("SHOVE", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("SHOVE", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestShoveWithNegativeIndex()
         {
-            this.TestWithNegativeIndex("SHOVE");
-        }
-
-        [TestMethod]
+            TestWithNegativeIndex("SHOVE");
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestYank()
         {
-            var values = this.GetValues(3);
-            this.Stack.Push(values);
+            var values = GetValues(3);
+            Stack.Push(values);
 
             interpreter.IntegerStack.Push(1);
-            this.Test(ExpressionTable.GetStatelessExpression(this.TypeName + ".YANK"));
-
-            Assert.AreEqual(values[0], this.Stack[0]);
-            Assert.AreEqual(values[2], this.Stack[1]);
-            Assert.AreEqual(values[1], this.Stack[2]);
-
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            Test(ExpressionTable.GetStatelessExpression(TypeName + ".YANK"));
+
+            Assert.AreEqual(values[0], Stack[0]);
+            Assert.AreEqual(values[2], Stack[1]);
+            Assert.AreEqual(values[1], Stack[2]);
+
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestYankWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("YANK", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("YANK", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestYankWithNegativeIndex()
         {
-            this.TestWithNegativeIndex("YANK");
-        }
-
-        [TestMethod]
+            TestWithNegativeIndex("YANK");
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestYankDuplicate()
         {
-            var values = this.GetValues(3);
-            this.Stack.Push(values);
+            var values = GetValues(3);
+            Stack.Push(values);
 
             interpreter.IntegerStack.Push(1);
-            this.Test(ExpressionTable.GetStatelessExpression(this.TypeName + ".YANKDUP"));
-
-            Assert.AreEqual(values[0], this.Stack[0]);
-            Assert.AreEqual(values[1], this.Stack[1]);
-            Assert.AreEqual(values[2], this.Stack[2]);
-            Assert.AreEqual(values[1], this.Stack[3]);
-
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            Test(ExpressionTable.GetStatelessExpression(TypeName + ".YANKDUP"));
+
+            Assert.AreEqual(values[0], Stack[0]);
+            Assert.AreEqual(values[1], Stack[1]);
+            Assert.AreEqual(values[2], Stack[2]);
+            Assert.AreEqual(values[1], Stack[3]);
+
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestYankDuplicateWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("YANKDUP", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("YANKDUP", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestYankDuplicateWithNegativeIndex()
         {
-            this.TestWithNegativeIndex("YANKDUP");
-        }
-
-        [TestMethod]
+            TestWithNegativeIndex("YANKDUP");
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CommonExpressionTest")]
         public virtual void TestStackdpeth()
         {
-            var values = this.GetValues(3);
-            this.Stack.Push(values);
-
-            this.Test(ExpressionTable.GetStatelessExpression(this.TypeName + ".STACKDEPTH"));
+            var values = GetValues(3);
+            Stack.Push(values);
+
+            Test(ExpressionTable.GetStatelessExpression(TypeName + ".STACKDEPTH"));
 
             // if stack is integer stack
-            if (this.Stack.Count != values.Length)
-            {
-                Assert.AreEqual(4, this.Stack.Count);
-                this.CheckOtherStacksAreEmpty();
+            if (Stack.Count != values.Length)
+            {
+                Assert.AreEqual(4, Stack.Count);
+                CheckOtherStacksAreEmpty();
             }
             else
             {
-                Assert.AreEqual(3, this.Stack.Count);
+                Assert.AreEqual(3, Stack.Count);
                 Assert.AreEqual(values.Length, interpreter.IntegerStack.Top);
             }
@@ -243,16 +297,16 @@
             for (var i = 0; i < argCount + 1; i++)
             {
-                var values = this.GetValues(i);
-                this.Stack.Push(values);
-
-                var fullInstructionname = string.Format(FullInstructionNameFormat, this.TypeName, instructionName);
-                this.Test(ExpressionTable.GetStatelessExpression(fullInstructionname));
+                var values = GetValues(i);
+                Stack.Push(values);
+
+                var fullInstructionname = string.Format(FullInstructionNameFormat, TypeName, instructionName);
+                Test(ExpressionTable.GetStatelessExpression(fullInstructionname));
 
                 for (var j = 0; j < i; j++)
                 {
-                    Assert.AreEqual(values[j], this.Stack[j]);
+                    Assert.AreEqual(values[j], Stack[j]);
                 }
 
-                this.CheckOtherStacksAreEmpty();
+                CheckOtherStacksAreEmpty();
                 interpreter.Clear();
             }
@@ -261,13 +315,13 @@
         protected void TestWithNegativeIndex(string instructionName)
         {
-            var values = this.GetValues(1);
-            this.Stack.Push(values);
+            var values = GetValues(1);
+            Stack.Push(values);
 
             interpreter.IntegerStack.Push(-1);
 
-            var fullInstructionname = string.Format(FullInstructionNameFormat, this.TypeName, instructionName);
-            this.Test(ExpressionTable.GetStatelessExpression(fullInstructionname));
-
-            Assert.AreEqual(values[0], this.Stack[0]);
+            var fullInstructionname = string.Format(FullInstructionNameFormat, TypeName, instructionName);
+            Test(ExpressionTable.GetStatelessExpression(fullInstructionname));
+
+            Assert.AreEqual(values[0], Stack[0]);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs	(revision 14398)
@@ -5,12 +5,14 @@
 {
     [TestClass]
-    public class MixedExpressionTests : InterpreterTest
+    public class MixedExpressionTests : ExpressionTest
     {
         const double Delta = 0.00000001;
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example1()
         {
-            this.interpreter.Interpret("( 2 3 INTEGER.* 4.1 5.2 FLOAT.+ TRUE FALSE BOOLEAN.OR )");
+            interpreter.Interpret("( 2 3 INTEGER.* 4.1 5.2 FLOAT.+ TRUE FALSE BOOLEAN.OR )");
 
             Assert.AreEqual(6, interpreter.IntegerStack.Top);
@@ -23,7 +25,9 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example2()
         {
-            this.interpreter.Interpret("( 5 1.23 INTEGER.+ ( 4 ) INTEGER.- 5.67 FLOAT.* )");
+            interpreter.Interpret("( 5 1.23 INTEGER.+ ( 4 ) INTEGER.- 5.67 FLOAT.* )");
 
             Assert.AreEqual(1, interpreter.IntegerStack.Top);
@@ -36,75 +40,87 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example3()
         {
-            this.interpreter.Interpret("( 5 INTEGER.DUP INTEGER.+ )");
-
-            Assert.AreEqual(10, interpreter.IntegerStack.Top);
-            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
-            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
-            Assert.IsTrue(interpreter.NameStack.IsEmpty);
-            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
-            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
-        }
-
-        [TestMethod]
+            interpreter.Interpret("( 5 INTEGER.DUP INTEGER.+ )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example4()
         {
-            this.interpreter.Interpret("( 5 CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) CODE.DO )");
-
-            Assert.AreEqual(10, interpreter.IntegerStack.Top);
-            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
-            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
-            Assert.IsTrue(interpreter.NameStack.IsEmpty);
-            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
-            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
-        }
-
-        [TestMethod]
+            interpreter.Interpret("( 5 CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) CODE.DO )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example5()
         {
-            this.interpreter.Interpret("( DOUBLE CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) CODE.DEFINE 5 DOUBLE )");
-
-            Assert.AreEqual(10, interpreter.IntegerStack.Top);
-            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
-            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
-            Assert.IsTrue(interpreter.NameStack.IsEmpty);
-            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
-            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
-        }
-
-        [TestMethod]
+            interpreter.Interpret("( DOUBLE CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) CODE.DEFINE 5 DOUBLE )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example6()
         {
-            this.interpreter.Interpret("( CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) DOUBLE CODE.DEFINE 5 DOUBLE )");
-
-            Assert.AreEqual(10, interpreter.IntegerStack.Top);
-            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
-            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
-            Assert.IsTrue(interpreter.NameStack.IsEmpty);
-            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
-            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
-        }
-
-        [TestMethod]
+            interpreter.Interpret("( CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) DOUBLE CODE.DEFINE 5 DOUBLE )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example7()
         {
-            this.interpreter.Interpret("( DOUBLE EXEC.DEFINE ( INTEGER.DUP INTEGER.+ ) 5 DOUBLE )");
-
-            Assert.AreEqual(10, interpreter.IntegerStack.Top);
-            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
-            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
-            Assert.IsTrue(interpreter.NameStack.IsEmpty);
-            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
-            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
-        }
-
-        [TestMethod]
+            interpreter.Interpret("( DOUBLE EXEC.DEFINE ( INTEGER.DUP INTEGER.+ ) 5 DOUBLE )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example8()
         {
-            this.interpreter.Configuration.TopLevelPushCode = true;
-
-            this.interpreter.IntegerStack.Push(5);
-            this.interpreter.Interpret(@"( CODE.QUOTE ( INTEGER.POP 1 )
+            interpreter.Configuration.TopLevelPushCode = true;
+
+            interpreter.IntegerStack.Push(5);
+            interpreter.Interpret(@"( CODE.QUOTE ( INTEGER.POP 1 )
                                            CODE.QUOTE ( CODE.DUP INTEGER.DUP 1 INTEGER.- CODE.DO INTEGER.* )
                                            INTEGER.DUP 2 INTEGER.< CODE.IF )");
@@ -119,8 +135,10 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example9()
         {
-            this.interpreter.IntegerStack.Push(5);
-            this.interpreter.Interpret("( 1 INTEGER.MAX 1 EXEC.DO*RANGE INTEGER.* )");
+            interpreter.IntegerStack.Push(5);
+            interpreter.Interpret("( 1 INTEGER.MAX 1 EXEC.DO*RANGE INTEGER.* )");
 
             Assert.AreEqual(120, interpreter.IntegerStack.Top);
@@ -133,8 +151,10 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example10()
         {
-            this.interpreter.IntegerStack.Push(5);
-            this.interpreter.Interpret("( 1 INTEGER.MAX 1 EXEC.DO*RANGE ( 2 INTEGER.* ) )");
+            interpreter.IntegerStack.Push(5);
+            interpreter.Interpret("( 1 INTEGER.MAX 1 EXEC.DO*RANGE ( 2 INTEGER.* ) )");
 
             Assert.AreEqual(2, interpreter.IntegerStack.Top);
@@ -147,12 +167,14 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example11()
         {
             var program = PushGPInterpreter.Encode("( INTEGER.= CODE.QUOTE FLOAT.* CODE.QUOTE FLOAT./ CODE.IF )");
 
-            this.interpreter.IntegerStack.Push(1, 1);
-            this.interpreter.FloatStack.Push(2.1, 0.7);
-
-            this.interpreter.Interpret(program);
+            interpreter.IntegerStack.Push(1, 1);
+            interpreter.FloatStack.Push(2.1, 0.7);
+
+            interpreter.Interpret(program);
 
             Assert.IsTrue(interpreter.IntegerStack.IsEmpty);
@@ -163,8 +185,8 @@
             Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
 
-            this.interpreter.Clear();
-            this.interpreter.IntegerStack.Push(1, 2);
-            this.interpreter.FloatStack.Push(2.1, 0.7);
-            this.interpreter.Interpret(program);
+            interpreter.Clear();
+            interpreter.IntegerStack.Push(1, 2);
+            interpreter.FloatStack.Push(2.1, 0.7);
+            interpreter.Interpret(program);
 
             Assert.IsTrue(interpreter.IntegerStack.IsEmpty);
@@ -177,12 +199,14 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example12()
         {
             var program = PushGPInterpreter.Encode("( INTEGER.= EXEC.IF FLOAT.* FLOAT./ )");
 
-            this.interpreter.IntegerStack.Push(1, 1);
-            this.interpreter.FloatStack.Push(2.1, 0.7);
-
-            this.interpreter.Interpret(program);
+            interpreter.IntegerStack.Push(1, 1);
+            interpreter.FloatStack.Push(2.1, 0.7);
+
+            interpreter.Interpret(program);
 
             Assert.IsTrue(interpreter.IntegerStack.IsEmpty);
@@ -193,8 +217,8 @@
             Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
 
-            this.interpreter.Clear();
-            this.interpreter.IntegerStack.Push(1, 2);
-            this.interpreter.FloatStack.Push(2.1, 0.7);
-            this.interpreter.Interpret(program);
+            interpreter.Clear();
+            interpreter.IntegerStack.Push(1, 2);
+            interpreter.FloatStack.Push(2.1, 0.7);
+            interpreter.Interpret(program);
 
             Assert.IsTrue(interpreter.IntegerStack.IsEmpty);
@@ -207,22 +231,26 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example13()
         {
-            this.interpreter.IntegerStack.Push(5);
-            this.interpreter.Interpret("( EXEC.Y ( ( FALSE 2 INTEGER.* ) EXEC.IF ( ) EXEC.POP ) )");
-
-            Assert.AreEqual(10, interpreter.IntegerStack.Top);
-            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
-            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
-            Assert.IsTrue(interpreter.NameStack.IsEmpty);
-            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
-            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
-        }
-
-        [TestMethod]
+            interpreter.IntegerStack.Push(5);
+            interpreter.Interpret("( EXEC.Y ( ( FALSE 2 INTEGER.* ) EXEC.IF ( ) EXEC.POP ) )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example14()
         {
-            this.interpreter.IntegerStack.Push(5);
-            this.interpreter.Interpret("( EXEC.Y ( ( 2 INTEGER.* INTEGER.DUP 1000 INTEGER.< ) EXEC.IF ( ) EXEC.POP ) )");
+            interpreter.IntegerStack.Push(5);
+            interpreter.Interpret("( EXEC.Y ( ( 2 INTEGER.* INTEGER.DUP 1000 INTEGER.< ) EXEC.IF ( ) EXEC.POP ) )");
 
             Assert.AreEqual(1280, interpreter.IntegerStack.Top);
@@ -235,9 +263,11 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExampleTest")]
         public void Example15()
         {
-            this.interpreter.IntegerStack.Push(10);
-            this.interpreter.FloatStack.Push(2);
-            this.interpreter.Interpret(@"( ARG FLOAT.DEFINE
+            interpreter.IntegerStack.Push(10);
+            interpreter.FloatStack.Push(2);
+            interpreter.Interpret(@"( ARG FLOAT.DEFINE
                                            EXEC.Y (
                                            ARG FLOAT.*
